Codeforces Round 900 (Div. 3)

How Much Does Daytona Cost?

所有长度为 \(1\) 的子数组,包含的元素必定是众数,所以只需判断 \(k\) 是否存在于数组中。

1
2
3
4
5
6
7
8
9
10
public static void solve() {
int n = io.nextInt(), k = io.nextInt();
boolean ok = false;
for (int i = 0; i < n; i++) {
if (k == io.nextInt()) {
ok = true;
}
}
io.println(ok ? "YES" : "NO");
}

Aleksa and Stack

两个奇数相加得到偶数,两个奇数相乘得到奇数,奇数不会被偶数整除,所以构造一个全是奇数的序列即可。

1
2
3
4
5
6
7
public static void solve() {
int n = io.nextInt();
for (int i = 0; i < n; i++) {
io.print(i * 2 + 1 + " ");
}
io.println();
}

Vasilije in Cacak

只要 \(x\) 在最小值和最大值之间,就总是可以被表示出来。

1
2
3
4
5
6
7
8
public static void solve() {
int n = io.nextInt(), k = io.nextInt();
long x = io.nextLong();
long a = (long) (1 + k) * k / 2;
long b = (long) (n - k + 1 + n) * k / 2;
if (x >= a && x <= b) io.println("YES");
else io.println("NO");
}

Reverse Madness

数组被 \(l\) 和 \(r\) 分段,每一段都是相互独立的,可以单独考虑段内的反转情况。可以发现段内反转总是中心对称的,每个元素是否反转,取决于该元素位置被反转次数的奇偶性,可以用两边向中间求累加和的方式统计,也可以用差分数组。(比赛时我没有统计奇偶性,而是抵消相邻的反转的相同部分)

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
public static void solve() {
int n = io.nextInt(), k = io.nextInt();
char[] s = io.next().toCharArray();
int[] l = new int[k];
for (int i = 0; i < k; i++) {
l[i] = io.nextInt() - 1;
}
int[] r = new int[k];
for (int i = 0; i < k; i++) {
r[i] = io.nextInt() - 1;
}
int q = io.nextInt();
int[] cnt = new int[n];
for (int i = 0; i < q; i++) {
cnt[io.nextInt() - 1]++;
}
for (int i = 0; i < k; i++) {
int sum = 0;
for (int a = l[i]; a <= (l[i] + r[i]) / 2; a++) {
int b = r[i] + l[i] - a;
sum += cnt[a] + cnt[b];
if (sum % 2 == 1) {
char c = s[a];
s[a] = s[b];
s[b] = c;
}
}
}
io.println(new String(s));
}

Iva & Pav

比较简单的做法是,计算每个比特位的前缀和,然后对每个查询二分答案的位置,将二分位置的值和 \(k\) 比较来判断二分的走向。比赛时我是用下面的方法做的,就是没想到二分,其实也可以不用二分,但是没看明白为什么,代码在此

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
public static void solve() {
int n = io.nextInt();
int[] a = new int[n];
for (int i = 0; i < n; i++) {
a[i] = io.nextInt();
}

// next[i][j] 表示 a[i] 的第 j 位等于 0 的下一个位置
int[][] next = new int[n + 1][32];
Arrays.fill(next[n], n);
for (int i = n - 1; i >= 0; i--) {
for (int j = 0; j < 32; j++) {
next[i][j] = next[i + 1][j];
if ((a[i] >> j & 1) == 0) {
next[i][j] = i;
}
}
}

int q = io.nextInt();
while (q-- != 0) {
int l = io.nextInt() - 1, k = io.nextInt();
if (a[l] < k) {
io.print("-1 ");
continue;
}

int lo = l, hi = n - 1;
while (lo <= hi) {
int mid = lo + (hi - lo) / 2;
int cur = 0;
for (int i = 0; i < 32; i++) {
if (next[mid][i] > mid && next[mid][i] == next[l][i]) {
cur |= 1 << i;
}
}
if (cur >= k) lo = mid + 1;
else hi = mid - 1;
}
io.print(hi + 1 + " ");
}
io.println();
}

Educational Codeforces Round 155 (Rated for Div. 2)

Rigged!

模拟。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
public static void solve() {
int n = io.nextInt();
int[] s = new int[n];
int[] e = new int[n];
for (int i = 0; i < n; i++) {
s[i] = io.nextInt();
e[i] = io.nextInt();
}
for (int i = 1; i < n; i++) {
if (s[i] >= s[0] && e[i] >= e[0]) {
io.println(-1);
return;
}
}
io.println(s[0]);
}

Chips on the Board

有两种情况,每行都放一个或者每列都放一个,然后模拟即可。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
public static void solve() {
int n = io.nextInt();
int[] a = new int[n];
int[] b = new int[n];
long suma = 0L;
int mina = Integer.MAX_VALUE;
for (int i = 0; i < n; i++) {
a[i] = io.nextInt();
suma += a[i];
mina = Math.min(mina, a[i]);
}
long sumb = 0L;
int minb = Integer.MAX_VALUE;
for (int i = 0; i < n; i++) {
b[i] = io.nextInt();
sumb += b[i];
minb = Math.min(minb, b[i]);
}
io.println(Math.min(suma + (long) minb * n, sumb + (long) mina * n));
}

Make it Alternating

所有连续重复数的个数就是最少操作次数,然后就是简单的应用组合数学。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
private static final int MOD = 998244353;

public static void solve() {
char[] s = io.next().toCharArray();
int n = s.length;
long cnt = n, sum = 1L;
for (int i = 0; i < n; ) {
int j = i + 1;
while (j < n && s[j] == s[j - 1]) {
j++;
}
sum = sum * (j - i) % MOD;
cnt--;
i = j;
}
for (long i = 1; i <= cnt; i++) {
sum = sum * i % MOD;
}
io.println(cnt + " " + sum);
}

Sum of XOR Functions

固定右端点,然后分别考虑每一位,计算答案,公式如下:

$$ \sum_{r=1}^{n}\sum_{l=1}^{r}f(l,r)\cdot (r-l+1) =\sum_{r=1}^{n}\sum_{i=0}^{31}\sum_{l=1}^{r}(f_{i}(1,r)\oplus f_{i}(1,l-1))\cdot (r-(l-1)) $$

可以发现对于每一位,\(f_{i}(1,r)\oplus f_{i}(1,l-1)\) 的值不是 \(1\) 就是 \(0\),只有当值为 \(1\) 时才会对答案有贡献。如果 \(f_{i}(1,r)=1\),那么右端点 \(r\) 的第 \(i\) 位对答案的贡献为 \((cnt[i][0]\cdot r-sum[i][0])\cdot 2^{i}\)(其中 \(cnt[i][0]\) 表示前缀中 \(f_{i}=0\) 的个数,\(sum[i][0]\) 表示前缀中 \(f_{i}=0\) 的区间长度之和),另一种情况同理。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
private static final int MOD = 998244353;

public static void solve() {
int n = io.nextInt();
int[] s = new int[n + 1];
for (int i = 0; i < n; i++) {
s[i + 1] = s[i] ^ io.nextInt();
}

long ans = 0L;
long[][] cnt = new long[32][2];
long[][] sum = new long[32][2];
for (int i = 0; i <= n; i++) {
for (int j = 0; j < 32; j++) {
int x = s[i] >> j & 1;
ans = (ans + (cnt[j][x ^ 1] * i - sum[j][x ^ 1]) % MOD * (1 << j)) % MOD;
cnt[j][x]++;
sum[j][x] += i;
}
}
io.println(ans);
}

Codeforces Round 899 (Div. 2)

Increasing Sequence

模拟,注意最后答案要减一。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
public static void solve() {
int n = io.nextInt();
int[] a = new int[n];
for (int i = 0; i < n; i++) {
a[i] = io.nextInt();
}

int b = 1;
for (int i = 0; i < n; i++) {
if (b == a[i]) b += 2;
else b += 1;
}
io.println(b - 1);
}

Sets and Union

比赛时写复杂了,就是枚举不选哪个数,使用位运算会很简单。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
public static void solve() {
int n = io.nextInt();

long xor = 0L;
long[] s = new long[n];
for (int i = 0; i < n; i++) {
int k = io.nextInt();
for (int j = 0; j < k; j++) {
s[i] |= 1L << io.nextInt();
}
xor |= s[i];
}

int ans = 0;
for (int i = 1; i <= 50; i++) {
if ((xor >> i & 1) != 1) continue;
long res = 0L;
for (int j = 0; j < n; j++) {
if ((s[j] >> i & 1) != 1) {
res |= s[j];
}
}
ans = Math.max(ans, Long.bitCount(res));
}
io.println(ans);
}

Card Game

思维题,没想出来。不管前两张牌如何操作,都必定可以拿到之后的所有正数牌,然后对前两张牌分类讨论即可。

1
2
3
4
5
6
7
8
9
10
11
12
13
public static void solve() {
int n = io.nextInt();
int[] a = new int[n];
for (int i = 0; i < n; i++) {
a[i] = io.nextInt();
}
long ans = 0L;
for (int i = 2; i < n; i++) {
ans += Math.max(0, a[i]);
}
ans += Math.max(0, a[0] + Math.max(0, n > 1 ? a[1] : 0));
io.println(ans);
}

Tree XOR

很典的换根 DP,因为第三题花费太长时间,导致差几分钟 AC。只要相邻的两个节点值不相同,它们就需要做一次操作。先以一个节点为根做 DFS,并记录所有节点的子树大小,和以该节点为根的成本。然后再做一次 DFS,换根计算代价的差值。(比赛时犯蠢,在换根的过程中打印答案,但是遍历不能保证从 \(1\) 到 \(n\) 的顺序,所以是错的)

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
private static long[] ans;
private static int[] value, sz;
private static List<Integer>[] g;

public static void solve() {
int n = io.nextInt();
value = new int[n];
for (int i = 0; i < n; i++) {
value[i] = io.nextInt();
}
g = new List[n];
Arrays.setAll(g, k -> new ArrayList<>());
for (int i = 0; i < n - 1; i++) {
int u = io.nextInt() - 1, v = io.nextInt() - 1;
g[u].add(v);
g[v].add(u);
}
sz = new int[n];
ans = new long[n];
dfs1(0, -1);
dfs2(0, -1);
for (int i = 0; i < n; i++) {
io.print(ans[i] + " ");
}
io.println();
}

private static void dfs1(int x, int fa) {
sz[x] = 1;
for (int y : g[x]) {
if (y == fa) continue;
dfs1(y, x);
sz[x] += sz[y];
ans[0] += (long) sz[y] * (value[x] ^ value[y]);
}
}

private static void dfs2(int x, int fa) {
for (int y : g[x]) {
if (y == fa) continue;
ans[y] = ans[x] + (long) (sz[0] - sz[y] - sz[y]) * (value[x] ^ value[y]);
dfs2(y, x);
}
}